import java.util.LinkedList;
import java.util.NoSuchElementException;

/**
 *
 */
public class BinomialHeap {
	
	/** 
	 * A list of all root nodes of the binomial trees. Note that this list is sorted by non-decreasing index of the nodes.
	 */
	LinkedList<BinHeapNode> rootNodesSorted;
	
	/** 
	 * constructor of an empty binomial heap
	 */
	public BinomialHeap() {
		rootNodesSorted = new LinkedList<BinHeapNode>();
	}
	
	/** 
	 * The merge method. 
	 * Goes through the sorted list of root nodes and always merges two binomial trees with the same index. In the end, there are no two subtrees with the same index. 
	 */
	private void cleanUp() {		
		//TODO: Add your code here.
	}
	
	/**
	 * Inserts a new value into the {@link BinomialHeap}.
	 * @param value The value to add. Our implementation can only handle {@link int} values.
	 * @return The {@link BinHeapNode} storing the new value.
	 */
	public BinHeapNode insert(int value) {
		//TODO: Add your code here. (You can use cleanUp(). )
		return null;
	}
	
	/**
	 * Deletes the smallest element from the BinomialHeap. 
	 * @return The smallest value in the BinomialHeap. 
	 * @throws NoSuchElementException if the heap is empty.
	 */
	public int deleteMin() throws NoSuchElementException{
		//TODO Add your code here. You can use the cleanUp().
		return 0;
	}
	
	/**
	 * Decreases the value of the specified node to the given value.
	 * @param node the node for which we want to decrease the value
	 * @param newValue The new value of the node.
	 * @throws IllegalArgumentException if the new value is larger than the old one
	 */
	public void decreaseKey (BinHeapNode node, int newValue) throws IllegalArgumentException {
		//TODO Add your code here.
	}
	
	/**
	 * Deletes the given {@link BinHeapNode}.
	 * @param node the {@link BinHeapNode} to delete
	 */
	public void delete(BinHeapNode node) {
		//TODO Add your code here.
	}
	
	/** Merges the two binomial trees with the specified root nodes to a new binomial tree.
	 * @param first The root node of the first binomial tree
	 * @param second The root node of the second binomial tree
	 * @return {@link BinHeapNode} The root node of the new binomial tree.
	 */
	private static BinHeapNode mergeTrees(BinHeapNode first, BinHeapNode second) {
		// TODO: Add your code here!
		return null;
	}
	
	@Override
	public String toString() {
		if (rootNodesSorted==null || rootNodesSorted.isEmpty()) return "empty heap";
		StringBuilder sb = new StringBuilder();
		for (BinHeapNode node : rootNodesSorted) {
			sb.append(node.toString() + " ");
		}
		return sb.toString();
	}
}
